#include <fstream.h>
#include "os.h"

bool buttons_check(int x1, int y1, int x2, int y2)
{
if(mouse_x >= x1 && mouse_x <= x2 && (mouse_b & 1 || mouse_b & 2) && mouse_y >= y1 && mouse_y <= y2){
return true;
}
return false;
}
void main_menu_return();
int main_menu();
int options_();
void quit_();
void intro_();
int read_text(BITMAP *bmp, const FONT *f, char* filename, int spacing, int start, int color);


BITMAP *button;
BITMAP *options;
BITMAP *quit;
BITMAP *start;
BITMAP *background;
BITMAP *dblbuffer;
int qqq;
int button_w = 200;
int button_h = 100;
int _start = 100;
int _options = 200;
int _quit = 300;
int main_menu()
{
if((button = load_bitmap("button.bmp", NULL)) == NULL){
	set_gfx_mode(GFX_AUTODETECT, 0, 0, 0, 0);
	allegro_message("Failed to load 'button'\n");
	return 1;
}
if((options = load_bitmap("options.bmp", NULL)) == NULL){
	set_gfx_mode(GFX_AUTODETECT, 0, 0, 0, 0);
	allegro_message("Failed to load 'options'\n");
	return 1;
}
if((quit = load_bitmap("quit.bmp", NULL)) == NULL){
	set_gfx_mode(GFX_AUTODETECT, 0, 0, 0, 0);
	allegro_message("Failed to load 'quit'\n");
	return 1;
}
if((start = load_bitmap("start.bmp", NULL)) == NULL){
	set_gfx_mode(GFX_AUTODETECT, 0, 0, 0, 0);
	allegro_message("Failed to load 'start'\n");
	return 1;
}
 /* make background */
background = create_bitmap(SCREEN_W, SCREEN_H);
clear_to_color(background, 12);
 /* mk double buffer */
dblbuffer = create_bitmap(SCREEN_W, SCREEN_H);
 /* INIT */
if(install_mouse() == -1){
	set_gfx_mode(GFX_AUTODETECT, 0, 0, 0, 0);
	allegro_message("Failed to find mouse\n");
	return 1;
}
show_mouse(dblbuffer);
text_mode(-1);
qqq=0;
do{
show_mouse(NULL);
blit(background, dblbuffer, 0, 0, 0, 0, SCREEN_W, SCREEN_H);
textout_centre(dblbuffer, font, operating_system(), SCREEN_W / 2, (SCREEN_H / 20), 200);
stretch_blit(button, dblbuffer, 0, 0, 50, 25, SCREEN_W / 2, _start, button_w, button_h);
masked_blit(start, dblbuffer, 0, 0, (SCREEN_W / 2) + 30, _start + 30, 110, 30);
stretch_blit(button, dblbuffer, 0, 0, 50, 25, SCREEN_W / 2, _options, button_w, button_h);
masked_blit(options, dblbuffer, 0, 0, (SCREEN_W / 2) + 30, _options + 30, 145, 30);
stretch_blit(button, dblbuffer, 0, 0, 50, 25, SCREEN_W / 2, _quit, button_w, button_h);
masked_blit(quit, dblbuffer, 0, 0, (SCREEN_W / 2) + 30, _quit + 30, 80, 30);
show_mouse(dblbuffer);
blit(dblbuffer, screen, 0, 0, 0, 0, SCREEN_W, SCREEN_H);
if(buttons_check(SCREEN_W / 2, _start, (SCREEN_W / 2) + button_w, _start + button_h)) qqq=1;
//if(buttons_check(SCREEN_W / 2, _options, (SCREEN_W / 2) + button_w, _options + button_h)) qqq=2;
if(buttons_check(SCREEN_W / 2, _quit, (SCREEN_W / 2) + button_w, _quit + button_h)) qqq=3;
}while(!qqq);
main_menu_return();
remove_mouse();
return qqq;
}
void main_menu_return()
{
destroy_bitmap(button);
destroy_bitmap(options);
destroy_bitmap(quit);
destroy_bitmap(start);
destroy_bitmap(dblbuffer);
}
int options_()
{
return 0;
}
void quit_()
{
clear_to_color(screen, 2);
textout_centre(screen, font, "Thanks for playing.", SCREEN_W / 2, SCREEN_H / 2, 100);
textout(screen, font, "Dustin Dettmer", SCREEN_W / 2 - 20, SCREEN_H - (SCREEN_H / 4), 110);
//textprintf(screen, font, 10, 10, 120, "%d", black_color);
int count = 20;
clear_keybuf();
 for(; count>0; count--){
	if((mouse_b & 1) || (mouse_b & 2)) break;
	if(keypressed()) break;
	rest(100);
 }
}
void intro_()
{
dblbuffer = create_bitmap(SCREEN_W, SCREEN_H);
clear_keybuf();
for(int x=SCREEN_H - 20; x>(-1100); x--){
	clear_to_color(dblbuffer, 2);
	if(read_text(dblbuffer, font, "intro.txt", 25, x, 200)) break;
	blit(dblbuffer, screen, 0, 0, 0, 0, SCREEN_W, SCREEN_H);
	if(keypressed()) break;
	rest(40);
}
clear_keybuf();
destroy_bitmap(dblbuffer);
}
int read_text(BITMAP *bmp, const FONT *f, char* filename, int spacing, int start, int color)
{
 ifstream text(filename);
 if(!text) return 1;

 char letters[256];

 while(!text.eof()){
  text.getline(letters, 100);
  textout_centre(bmp, f, letters, SCREEN_W / 2, start+=spacing, color);
 }
 return 0;
}

