#include "functionfix.h"
volatile int character_frame = 0;
int old_character_frame = 0;
bool advance_character_frame = true;
volatile int character_side_frame = 0;
int old_character_side_frame = 0;
bool advance_character_side_frame = true;
volatile int fireball_frame = 0;
int old_fireball_frame = 0;
bool advance_fireball_frame = true;
volatile bool fire_orno = false;
bool forgetful_fire_orno = false;
void fire_timer()
{
if(!fire_orno)fire_orno = true;
}
END_OF_FUNCTION(fire_timer)
void character_timer()
{
advance_character_frame ? (character_frame <= 12 ? character_frame++ : character_frame = 0) : character_frame = 6;
}
END_OF_FUNCTION(character_timer)
void character_side_timer()
{
advance_character_side_frame ? (character_side_frame <= 12 ? character_side_frame++ : character_side_frame = 0) : character_side_frame = 0;
}
END_OF_FUNCTION(character_side_timer)
void fireball_timer()
{
if(advance_fireball_frame) fireball_frame <= 2 ? fireball_frame++ : fireball_frame = 0;
}
END_OF_FUNCTION(fireball_timer)
int init_timers()
{
if(install_int(fire_timer, 1500)){	// cool down time (dont make this too fast as it will overload the memory)
	set_gfx_mode(GFX_TEXT, 0, 0, 0, 0);
	allegro_message("Failed to start cool down timer\n");
	return 1;
}
if(install_int(character_timer, 25)){
	set_gfx_mode(GFX_TEXT, 0, 0, 0, 0);
	allegro_message("Failed to start character timer\n");
	return 1;
}
if(install_int(character_side_timer, 15)){
	set_gfx_mode(GFX_TEXT, 0, 0, 0, 0);
	allegro_message("Failed to start character timer #2\n");
	return 1;
}
if(install_int(fireball_timer, 120)){
	set_gfx_mode(GFX_TEXT, 0, 0, 0, 0);
	allegro_message("Failed to start fireball timer\n");
	return 1;
}
LOCK_VARIABLE(fire_orno);
LOCK_FUNCTION(fire_timer);
LOCK_VARIABLE(character_frame);
LOCK_FUNCTION(character_timer);
LOCK_VARIABLE(character_side_frame);
LOCK_FUNCTION(character_side_timer);
LOCK_VARIABLE(fireball_frame);
LOCK_FUNCTION(fireball_timer);
return 0;
}
