#include <allegro.h>
#include "time_stuff.h"			// must be first
#include "image_loading.h"		// must be second
#include "objects.h"
#include "main_menu.h"
#include "levels.h"			// must be last

BITMAP *buffer;
BITMAP *level_b;

int init();
int actual_game();
void mem_leakage();
void attempt_mem_return()
{
main_menu_return();
mem_leakage();
}
END_OF_FUNCTION(attempt_mem_return)


int main()
{
if(init()){
	set_gfx_mode(GFX_TEXT, 0, 0, 0, 0);
	allegro_message("Failed to start game\n");
	return 1;
}
int qq=0;
do{
switch(main_menu()){
  case 1:
   intro_();
   if(actual_game()){
	set_gfx_mode(GFX_TEXT, 0, 0, 0, 0);
	allegro_message("Error running game\n");
	return 1;
   }
   break;
  case 2:
   if(options_()){
	set_gfx_mode(GFX_TEXT, 0, 0, 0, 0);
	allegro_message("Error setting options, press any key to resume or esc to quit\n");
	clear_keybuf();
	if ((readkey() >> 8) == KEY_ESC) return 2;
	break;
   }
   break;
  default:
   quit_();
   qq = 1;
 }
 }while(qq != 1);


mem_leakage();
allegro_exit();
return 0;
}
END_OF_MAIN()

int init()
{
allegro_init();
set_color_depth(24);
if(set_gfx_mode(GFX_AUTODETECT, 640, 400, 0, 0)){
        set_gfx_mode(GFX_TEXT, 0, 0, 0, 0);
        allegro_message("Failed to load graphics mode\n");
        return 1;
}
LOCK_FUNCTION(attempt_mem_return);
set_window_close_hook(attempt_mem_return);
if(set_display_switch_mode(SWITCH_PAUSE) == -1)
if(set_display_switch_mode(SWITCH_BACKGROUND) == -1)
if(set_display_switch_mode(SWITCH_NONE) == -1)
if(set_display_switch_mode(SWITCH_BACKAMNESIA) == -1)
set_display_switch_mode(SWITCH_AMNESIA);
install_keyboard();
if(init_timers()){
        set_gfx_mode(GFX_TEXT, 0, 0, 0, 0);
        allegro_message("Failed to load timers\n");
        return 1;
}
if(load_images()){
        set_gfx_mode(GFX_TEXT, 0, 0, 0, 0);
        allegro_message("Failed to load images\n");
        return 1;
}
level_b = create_bitmap(1810, 910);
buffer = create_bitmap(SCREEN_W, SCREEN_H);
return 0;
}
void mem_leakage()
{
unload_images();
delete_jellies();
destroy_bitmap(buffer);
}
void input();
void output();

		/** GAMEPLAY HERE **/		int actual_game()
{
level_intro(current_lvl);
clear_to_color(level_b, 200);
draw_level(level_b, level_b, 5, 5, current_lvl);
chara_x = chara_y = old_chara_x = old_chara_y = 20;
chara_dir = scrollin_x = scrollin_y = 0;
install_mouse();
do{
clear_to_color(buffer, 200);
advance_fireball_frame = true;
blit(level_b, buffer, scrollin_x, scrollin_y, 0, 0, SCREEN_W, SCREEN_H);

for(int h=0; h<5; h++)
 process_windows(enemy[h], buffer, level_b);

if(chara_dir < 2 && (mouse_b& 1)) fire(buffer, 43+chara_x, 23+chara_y, mouse_x, mouse_y);
process_character(buffer, buffer);					//includes scroll
if(chara_dir >= 2 && (mouse_b& 1)) fire(buffer, 43+chara_x, 23+chara_y, mouse_x, mouse_y);

draw_rle_sprite(buffer, fireball[fireball_frame], mouse_x, mouse_y);

blit(buffer, screen, 0, 0, 0, 0, SCREEN_W, SCREEN_H);
}while(!key[KEY_ESC]);
remove_mouse();
level_quit(current_lvl);
return 0;
}


